function estimates = fitcurve(t, data, beta, dim)
% Call fminsearch with a random starting point.
fval = 1;
%disp(beta)
%options = optimset('MaxFunEvals', 10000, 'Display', 'iter', 'MaxIter', 1000);
options = optimset('MaxFunEvals', 100000, 'Display', 'none', 'MaxIter', 10000);
[estimates, fval] = fminsearch(@expfun, beta, options, dim);
disp(fval);
%disp(estimates(3));
% expfun accepts curve parameters as inputs and outputs sse,
% the sum of squares error for A * exp(-lambda * t) - Data.
    function ssee = expfun(params, dim)
        ssee = 1e20;
        D = params(1);
        alpha = params(2);
        if size(params,2)==3
            ordinate = params(3);
        else
            ordinate = 0;
        end
        datadimension = dim;
        FittedCurve = 2.*dim.*D.*t.^alpha+ordinate;
        
        % Penalize deviations in first timesteps (including y axis
        % intercept)
        penaltyWeight = 1; %var(data);
        if size(t) > 1
            penalty = lerp([penaltyWeight, 1], [1, size(t)]);
        else
            penalty = ones(size(t), 1);
        end;
        ErrorVector = FittedCurve - data;
        ErrorVector = ErrorVector.*penalty;
        
        
        ssee = sum(ErrorVector .^ 2);
        
        
        
        %ssee = pearsonsr(FittedCurve, data);
    end
end