function [alphaMatrix, resnormMatrix, fitMatrix, allAlphas, allDs, allResnorms, allDresiduals] = estimateAlpha(timeStamp, msqDpl, D, timeStampIndeces)
% Contains diffusion coefficients estimated using the MLE method. It is not fitted here. 

dim = 3;
numberOfTracks = size(msqDpl,2);
warning off;
k = 1;
fitToFirstPercent = 0.25;

for i = 1:numberOfTracks % Iterate through tracks and subtracks
	%disp(['Track #: ' num2str(i)]);
	numberOfSubTracks = size(msqDpl{i}, 2);
	for j = 1:numberOfSubTracks
		disp(['k: ' num2str(k)]);
		% Read timeStamp and msd of current subtrack
		xdata = timeStampIndeces{i}{j};
		ydata = msqDpl{i}{j};
		% Fit only 1:fitToFirstPercent, because later steps are too noisy
		if length(ydata > 10)
			fitToTimepoint = round(find(ydata==max(ydata)).*fitToFirstPercent);
		else
			fitToTimepoint = round(find(ydata==max(ydata)).*fitToFirstPercent.*3); % Note this leads to a bias 
		end;

		%%%%%%%%%%% Now do the fitting %%%%%%%%%%%%%
		[fitparams,resnorm,r,exitflag,output,lambda,J] = fitMSD(xdata(1:fitToTimepoint), ydata(1:fitToTimepoint), [D{i}(j) 1 0]);
		% Variables all<NAME>s contain fitparams in vectorized form for statistics
		% Variables <NAME>Matrix contain the params in the respective position of the subtrack for plotting
		alphaMatrix{i}(j) = fitparams(2);
		allDs(k) = fitparams(1);
		allAlphas(k) = fitparams(2);
		allResnorms(k) = resnorm; 
		allDresiduals(k) = (fitparams(1)-D{i}(j))./D{i}(j); % How much the fitted D deviates from MLE-based D
		k = k+1;
		fitMatrix{i}{j} = msdCurve(fitparams, xdata(1:fitToTimepoint));
		%resnormMatrix{i}(j) = resnorm;
		resnormMatrix{i}(j) = pearsonsr(ydata(1:fitToTimepoint), fitMatrix{i}{j});
		%figure;
		%plot(xdata, ydata, xdata, fitMatrix{i}{j});
	end;

end
warning on;



