function ydata = gaussian(x, xdata)
% Calculates Gaussian function with parameters x = [a b c d]
% Where a .. height (amplitude)
%       b .. mean (s.t. denoted as )
%       c .. related to standard deviation sigma by c = sigma./sqrt(2)
%       d .. ordinate translation (y-Achsenabschnitt)
% Useful also for fitting a Gaussian to a series 
% exp [x,resnorm] = lsqcurvefit(@gaussian,[0.4 2.3 1 0.05],coordz, fluoIntensityAlongZ_agg)

ydata = x(1).*exp(-((xdata-x(2)).^2)./(x(3).^2))+x(4);