function Yi = lerp(Bounds, Pos)
% Linear interpolation of in 1D
% Yi = lerp(Bounds, Pos)
% Yi..interpolated column vector limited by Bounds on both sides
% Bounds(1).. lowerBound
% Bounds(2).. upperBound
% Pos(1).. position of Bounds(1)
% Pos(2).. position of Bounds(2)


lowerBound = Bounds(1);
upperBound = Bounds(2);
lowerPos = 1;
upperPos = Pos(2)-Pos(1);
Yi = zeros(upperPos+1, 1);
Yi(1) = lowerBound;
Yi(upperPos+1) = upperBound;

%Calc Number of Zeros/Gaps
n = upperPos-1;

% Interpolation Coefficient
alpha = 1/(n+1);

% Difference
difference = upperBound-lowerBound;

% Now interpolate
for (i=2:n+1)
    
    Yi(i) = lowerBound + (i-1).*alpha.*(difference);
    
end
