function [outputVec] = proximityFilter(inputVec, proximityTolerance)
% [outputVec] = proximityFilter(inputVec, proximityTolerance)
% Bins inputVec with binwidth = proximityTolerance
% Elements closer than proximityTolerance are likely to end up in same bin
% outputVec returns average of respective bin
% inputVec can be both row or column vector
% outputVec is always row vector


% Add Padding
if size(inputVec,2) < size(inputVec,1)
	inputVec = inputVec';
end
%inputVec = [0, inputVec, 0];

% Use binning instead of branching; try binning with shifted bins and then combining somehow.
maxy = max(inputVec);
numberOfBins = floor(maxy/proximityTolerance);
[n, x] = hist(inputVec, numberOfBins);
outputVec = round(x(find(n>0)));


