function [trajectory, displacements] = randomwalk1D(numberOfTimesteps, D, alpha, deltaT, startpos)

stepsize = sqrt(2*D*deltaT.^alpha);

trajectory = zeros(numberOfTimesteps, 1);

for t = 2:numberOfTimesteps %Start with 2, so first pos is always 0
	direction = 1;
	
	displacements(t) = stepsize*2*(rand-0.5);
	startpos = startpos + displacements(t);
	trajectory(t) = startpos;
end

