function [grayvalueMatrix, pixelTrackMatrix, corr] = track2gray(graydataPath, graydataBasename, maskPath, maskBasename, trackMatrix, trafoMatrix, trackIndeces, voxelsize, zSlices)
% if it hangs throwing a ??? Attempted to access labeledStack(0,0,0); index must be a positive integer or logical.
% try setting trackIndeces(tpos:length(trackIndeces), trackNumber) = 0;
% Iterate until done. 

currentDir = pwd;
% Generate list file with filenames 
% Only works with unix file systems
eval(['cd ' graydataPath]);
eval('ls *.tif > tiffList');

% Read file names line by line from file
fid = fopen('tiffList', 'rt');
y = 1;
while feof(fid) == 0 
    tline = fgetl(fid);
    graydataList(y)=cellstr(tline);
    y=y+1; 
end
fclose(fid);

% Remove list file from directory
unix('rm tiffList');

% Generate list file with filenames 
% Only works with unix file systems
eval(['cd ' maskPath]);
eval('ls *.tif > tiffList');

% Read file names line by line from file
fid = fopen('tiffList', 'rt');
y = 1;
while feof(fid) == 0 
    tline = fgetl(fid);
    maskList(y)=cellstr(tline);
    y=y+1; 
end
fclose(fid);

% Remove list file from directory
unix('rm tiffList');


% Initialize dimensions
timesteps = size(trackIndeces,1)
%zSlices = size(graydataList, 2)./timesteps
numberOfTracks = size(trackMatrix, 2)
numberOfObjects = numberOfTracks/3

% output path information 
graydataPath
graydataBasename
maskPath
maskBasename


% Read first image stack for bleach correction mask
for i = 1:zSlices
    firstImage(:,:,i) = imread([graydataPath '/' char(graydataList(i))]);
end
xDim = size(firstImage,1)
yDim = size(firstImage,2) % Do you still need to swap x and y now?

% Now generate mask for nucleus to obtain correction factors for
% the bleach correction
testMax = max(firstImage, [], 3);
se = strel('disk', 3, 0); % Structuring element for segmentation
level = graythresh(testMax); % Otsu thresholding
wholeNucleus = imdilate(imdilate(imerode(imfill(im2bw(testMax,level), 'holes'), se), se),se);
%imagesc(testMax); colorbar; figure; imagesc(wholeNucleus);
imagesc(double(testMax)./double(wholeNucleus));
initialIntensity = applyMask(double(wholeNucleus), double(testMax)); % First time step, initial intensity

% Pre-allocate
grayStack = zeros(xDim, yDim, zSlices);
maskStack = zeros(xDim, yDim, zSlices);
grayvalueMatrix = zeros(timesteps, numberOfTracks);




for trackNumber = 1:3:numberOfTracks
    % Retransform tracks to Tikal coordinate system
    trackMatrix(:,trackNumber) = trackMatrix(:,trackNumber) + trafoMatrix(:,1);
    trackMatrix(:,trackNumber+1) = trackMatrix(:,trackNumber+1) + trafoMatrix(:,2);
    trackMatrix(:,trackNumber+2) = trackMatrix(:,trackNumber+2) + trafoMatrix(:,3);
    
    % Transform trackMatrix to pixel coordinates
    trackMatrix(:,trackNumber) = round(trackMatrix(:,trackNumber)./voxelsize(1));
    trackMatrix(:,trackNumber+1) = round(trackMatrix(:,trackNumber+1)./voxelsize(2));
    trackMatrix(:,trackNumber+2) = round(trackMatrix(:,trackNumber+2)./voxelsize(3));
end 

% Store pixel coordinates here
pixelTrackMatrix = trackMatrix;

% Array to store bleach correction factors
corr = ones(timesteps, 1);

%%%%%% Iterate through all time steps %%%%%%%
for tPos = 1:timesteps
    zS = 1;
    % Load t-th stack for NB mask and gray value stack, and generate mask
    % for bleach correction
    for zPos = (tPos-1)*zSlices+1:zSlices*tPos
        %tPos
        %zPos
	%zS 
        %disp([graydataPath '/' char(graydataList(zPos))]);
        grayStack(:,:,zS)=imread([graydataPath '/' char(graydataList(zPos))]); 
        maskStack(:,:,zS)=imread([maskPath '/' char(maskList(zPos))]); 
        zS = zS+1;
        testMax = max(grayStack, [], 3);
        %level = graythresh(testMax); % Otsu thresholding
        %wholeNucleus = imdilate(imdilate(imerode(imfill(im2bw(testMax,level), 'holes'), se), se),se);
        corr(tPos) = applyMask(double(wholeNucleus), double(testMax));
    end
    
    % Convert to binary mask
    maskStack = maskStack./max(max(max(maskStack))); % Still necessary?
    
    % Label all objects in mask stack at current tPos
    [labeledStack, num] = bwlabeln(maskStack);
    %tPos
    
    for trackNumber = 1:3:numberOfTracks
        realTrackNumber = ceil(trackNumber./3);
        disp(['tPos :' num2str(tPos) ' trackNumber: ' num2str(ceil(trackNumber/3))])
        if (trackIndeces(tPos, realTrackNumber)==1) % Only valid trackIndeces are used
            % Seed coordinates (COM of objects)
            x = trackMatrix(tPos, trackNumber+1); % Swap x and y
            y = trackMatrix(tPos, trackNumber);
            z = trackMatrix(tPos, trackNumber+2);
            
                    
            % Identify Label # with track
            objectNumber = labeledStack(x, y, z);
        
            % find label # in stack, get coords
            object = find(labeledStack==objectNumber);
        
            % Read corresponding gray values and store mean in grayvalueMatrix
            grayVal = mean(mean(mean(grayStack(object))));
            grayvalueMatrix(tPos, trackNumber) = grayVal;
        end;
    end;
end;
% Calculate correction factors
corr = initialIntensity./corr
% Condense grayvalueMatrix
grayvalueMatrix = grayvalueMatrix(:,1:3:numberOfTracks);
% Do bleach correction
for r = 1:numberOfObjects grayvalueMatrix(:,r) = grayvalueMatrix(:,r).*corr; end

% Return to current directory
cd(currentDir);